/*******************************************************************************
 * DISCLAIMER
 * This software is supplied by Renesas Electronics Corporation and is only
 * intended for use with Renesas products. No other uses are authorized. This
 * software is owned by Renesas Electronics Corporation and is protected under
 * all applicable laws, including copyright laws.
 * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
 * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
 * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
 * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
 * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
 * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
 * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
 * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
 * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * Renesas reserves the right, without notice, to make changes to this software
 * and to discontinue the availability of this software. By using this software,
 * you agree to the additional terms and conditions found by accessing the
 * following link:
 * http://www.renesas.com/disclaimer
 * (C) 2012-2015 Renesas Electronics Corporation All rights reserved.
*******************************************************************************/

#ifndef _SLIP_H
#define _SLIP_H

/******************************************************************************
	Includes
******************************************************************************/

//#include <stdint.h>
#include "..\..\globdef.h"

#define AG_BLE_OFF		( 0 )
#define AG_BLE_RX_ON	( 1 )
#define AG_BLE_TX_ON	( 2 )
#define BLE_OFF         ( AG_BLE_OFF == ble_ag_status )
#define BLE_RX_ON       ( AG_BLE_RX_ON == ble_ag_status )
#define BLE_TX_ON		( AG_BLE_TX_ON == ble_ag_status )
#define STOP_BLE		{ ble_ag_status = AG_BLE_OFF; }
#define START_BLE_RX	{ ble_ag_status = AG_BLE_RX_ON; }
#define START_BLE_TX	{ ble_ag_status = AG_BLE_TX_ON; }



/******************************************************************************
	Typedef definitions
******************************************************************************/

/* generic argument for client */
typedef void*   slipArg_t;

/* receive message callback */
typedef bool_t	(*slipCbRxIndication_t)(serialMsg_t* rxMsg,
										slipArg_t    arg);




#ifndef _R_SLIP_C
extern uint8_t	ble_ag_status;
extern uint16_t	txLength_slip;
extern uint8_t *rtx232_buf_slip;
#endif	// ifndef _R_SLIP_C

/******************************************************************************
	Functions Prototypes
******************************************************************************/



/******************************************************************************
Function:		BLE_GetReceivedByte
Description:	Receive buffer full interrupt service routine
Input:			none
Output:			none
******************************************************************************/
void BLE_GetReceivedByte(uint8_t key_data);

void R_Slip_Setup(void);

/* Register a Client */
void R_Slip_RegisterClient(slipCbRxIndication_t		cbRxIndication);
//						   slipCbTxIndication_t		cbTxIndication,
//						   slipCbFailIndication_t	cbFailIndication,
//						   slipArg_t				cbArg);

/* Transmit a Message */
bool_t R_Slip_SendMessage(uint8_t sapID, uint8_t msgID, uint8_t* payload, uint8_t length);

/* set buffer for RxMsg */
void R_Slip_SetRxMsg(serialMsg_t* rxMsg);


void R_Slip_Task(void);


#endif  //  _SLIP_H
